<bugID>1029926<Summary>Add a field to install.rdf for add-ons that are compatible with electrolysis</Summary><Description>Created attachment 8445581
addon-mgr

In bug 1017320, we're going to add a bunch of shims so that add-ons will work in electrolysis without changes. However, I want add-ons to be able to opt out of the shims if they've been updated to work in e10s. I figure that a field in install.rdf would be the best way to do this. We've also talked about using a separate targetApplication, but that seems a little extreme to me.

What makes this a little difficult is that we need to know whether an add-on needs compatibility shims before we load any code for it. The add-on manager seems to try really hard to avoid reading install.rdf during startup. I've come up with a WIP patch to do this and I'd like some feedback. It doesn't yet handle installation of restartless add-ons, and I'm interested in ideas there. As background, the patch needs to call Cu.registerAddonInterposition if the add-on needs shims.

Irving, are you the right person to look this over?</Description></bugID>